from random import randint


# Task 1. Перевести строку в массив
# "Robin Singh" => ["Robin”, “Singh"]
# "I love arrays they are my favorite" =>
# ["I", "love", "arrays", "they", "are", "my", "favorite"]
str_1_1 = "Robin Singh".split()
str_1_2 = "I love arrays they are my favorite".split()
print("Task 1. :", str_1_1, '\n', str_1_2)


# Task 2. Дан список: [‘Ivan’, ‘Ivanou’], и 2 строки: Minsk, Belarus
# Напечатайте текст: “Привет, Ivan Ivanou! Добро пожаловать в Minsk Belarus”
list_1 = ["Ivan", "Ivanou"]
str_2_1 = "Minsk"
str_2_2 = "Belarus"
print("Task 2. :", f"Привет, {list_1[0]} {list_1[1]}!"
      f" Добро пожаловать в {str_2_1} {str_2_2}")


# Task 3. Дан список ["I", "love", "arrays", "they", "are", "my", "favorite"]
# сделайте из него строку => "I love arrays they are my favorite"
arr = ["I", "love", "arrays", "they", "are", "my", "favorite"]
print("Task 3. :", " ".join(arr))


# Task 4. Создайте список из 10 элементов,
list_4 = [randint(-10, 100) for i in range(10)]
# вставьте на 3-ю позицию новое значение,
list_4[2] = 34
# удалите элемент из списка под индексом 6
del list_4[6]
print("Task 4. :", list_4)


# Task 5. Есть 2 словаря
# a = { 'a': 1, 'b': 2, 'c': 3}
# b = { 'c': 3, 'd': 4,'e': “”}
# 1. Создайте словарь, который будет содержать в себе
# все элементы обоих словарей
a = {'a': 1, 'b': 2, 'c': 3}
b = {'c': 3, 'd': 4, 'e': ''}
ab = {**a, **b}
print("Task 5.1. :", ab)
# 2. Обновите словарь “a” элементами из словаря “b”
a.update(b)
print("Task 5.2. :", a)
# 3. Проверить что все значения в словаре “a” не пустые либо не равны нулю
print("Task 5.3. :", all(a.values()))
# 4. Проверить что есть хотя бы одно пустое значение
# (результат выполнения должен быть True)
print("Task 5.4. :", "" in a.values())
# 5. Отсортировать словарь по алфавиту в обратном порядке
print("Task 5.5. :", dict(sorted(a.items(), reverse=True)))
# 6. Изменить значение под одним из ключей и вывести все значения
b['e'] = 10
print("Task 5.6. :", b)


# Task 6. Создать список из элементов list_a = [1,2,3,4,4,5,2,1,8]
list_a = [1, 2, 3, 4, 4, 5, 2, 1, 8]
# a. Вывести только уникальные значения и сохранить их в отдельную переменную

# b. Добавить в полученный объект значение 22

# c. Сделать list_a неизменяемым
list_a = tuple(list_a)
# d. Измерить его длинну
print("Task 6.d :", len(list_a))


# Задачи на закрепление форматирования:
# Task X. Есть переменные a=10, b=25
# Вывести 'Summ is <сумма этих чисел> and diff = <их разница>.'
# При решении задачи использовать оба способа форматирования


# Task Y. Есть список list_of_children = [“Sasha”, “Vasia”, “Nikalai”]
# Вывести “First child is <первое имя из списка>, second is “<второе>”,
# and last one – “<третье>””


# Task 1* Вам передан массив чисел.
# Известно, что каждое число в этом массиве имеет пару,
# кроме одного: [1, 5, 2, 9, 2, 9, 1] => 5
# Напишите программу, которая будет выводить уникальное число

# Task 2* Дан текст, который содержит различные английские буквы
# и знаки препинания.
# Вам необходимо найти самую частую букву в тексте.
# Результатом должна быть буква в нижнем регистре.
# При поиске самой частой буквы, регистр не имеет значения,
# так что при подсчете считайте, что "A" == "a".
# Убедитесь, что вы не считайте знаки препинания,
# цифры и пробелы, а только буквы.
# Если в тексте две и больше буквы с одинаковой частотой,
# тогда результатом будет буква,
# которая идет первой в алфавите. Для примера,
# "one" содержит "o", "n", "e" по одному разу, так что мы выбираем "e".

# "a-z" == "a"
# "Hello World!" == "l"
# "How do you do?" == "o"
# "One" == "e"
# "Oops!" == "o"
# "AAaooo!!!!" == "a"
# "a" * 9000 + "b" * 1000 == "a"
